--- u-boot-2011.06_original/common/cmd_update_misc.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_update_misc.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,69 @@
+#include "cnc_util.h"
+
+#if defined(CONFIG_AUTO_UPDATE) && defined(CONFIG_USB_STORAGE)
+
+int do_nand(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+extern int do_auto_update(unsigned int size);
+//---------------------------------------------------------------------------------------------------------------------------------------------------
+int do_update (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	char *pCmd[5] = { "nand", "read", NULL, NULL, NULL};
+	char TempCmd1[16], TempCmd2[16], TempCmd3[16];
+
+	pCmd[2] = TempCmd1;
+	pCmd[3] = TempCmd2;
+	pCmd[4] = TempCmd3;
+
+	unsigned int *ptr, size;
+	int i;
+
+	if(argc == 1)
+	{
+		do_auto_update(0);
+	}
+	else if(argc == 2)
+	{
+		if(*argv[1] == '*')
+		{
+			ptr = (unsigned int*) simple_strtoul(argv[1] + 1, NULL, 16);
+			return do_auto_update(*ptr);
+		}
+		else
+		{
+			return do_auto_update(simple_strtoul(argv[1], NULL, 16));
+		}
+	}
+	else if(argc == 3)
+	{
+		sprintf(TempCmd1, "0x%x", CONFIG_USB_UPGRADE_DATA_ADDR);
+		sprintf(TempCmd2, "%s", argv[1]);
+		if(*argv[2] == '*')
+		{
+			ptr =  (unsigned int*) simple_strtoul(argv[2] + 1, NULL, 16);
+			size = *ptr;			
+		}
+		else
+		{
+			size = simple_strtoul(argv[2], NULL, 16);
+		}
+		sprintf(TempCmd3, "0x%x", size);
+		printf("nand read %s %s %s\n", pCmd[2], pCmd[3], pCmd[4]);
+		i = do_nand(NULL, 0, 5, pCmd);
+		if(i)
+		{
+			return i;
+		}
+		return do_auto_update(size);
+	}
+    return 0;
+}
+
+U_BOOT_CMD(
+	update_misc, 3, 0, do_update,
+	"update_misc - update your u-boot.bin / uImage / ramdiskg.img by USB storage device. \n",
+	"update_misc [CSV_LIST_OF_MTD_PARTITION_NAME] [force] [filename-url]\n"
+	"update_misc force splash,kernel,jffs2 usb://cnc83xxS.bin - update splash, kernel and jffs2. If it is available in cnc83xxS.bin from USB drive and also ignore version checking\n"
+	"update_misc force splash,kernel,jffs2 tftp://192.168.1.2/cnc83xxS.bin - update splash, kernel and jffs2. If it is available in image cnc83xxS.bin from tftp server and also ignore version checking\n"
+);
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_upgrade.c u-boot-2011.06/common/cmd_upgrade.c
--- u-boot-2011.06_original/common/cmd_upgrade.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_upgrade.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,449 @@
+#if 0
+#include <common.h>
+#include <command.h>
+#include <asm/errno.h>
+
+DECLARE_GLOBAL_DATA_PTR;
+
+//upgrade spiuboot force cavm18_bootloader.bin
+//upgrade nethd // filename defaults to cavm18_netHD.sbin
+
+
+//usb start
+//fatload usb 0 0x2000000 su-boot.bin
+//sfer 0 +${filesize}
+//sfwr 0x2000000 0 ${filesize}
+
+//usb start
+//fatload usb 0x0 0x02100000 ubootpImage
+//saveenv
+//nand erase 0x02400000 ${filesize}
+//nand write 0x02100000 0x02400000 ${filesize}
+//reset
+
+//#define MAX_UBOOT_SIZE (0x80000)
+#define MAX_SPI_UBOOT_SIZE_STRING ("0x60000")
+#define MAX_UBOOT_SIZE_STRING ("0x80000")
+
+#define FILE_MEM_ADDR_STRING          ("0x02100000")
+#define FILE_MEM_ADDR                 (0x02100000)
+#define TMP_UBOOT_ADDR_STRING         ("0x0200000c")
+#define TMP_UBOOT_ADDR                (0x0200000c)
+#define SECURE_IMAGE_FILENAME         "cavm18_netHD.sbin"
+#define SECURE_IMAGE_EXTENSION        "sbin"
+#define INSECURE_UBOOT_IMAGE_FILENAME "cavm18_bootloader.bin"
+#define INSECURE_IMAGE_FILENAME       "cavm18_nethd.bin"
+#define UPGRADE_SPIUBOOT              0
+#define UPGRADE_UBOOT       	      1
+#define UPGRADE_NETHD	              2
+
+extern int do_fat_fsload (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+extern int do_sflashwr(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]);
+extern int do_sflasher(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]);
+extern int do_sflashre(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+extern int do_usb(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[]);
+extern int do_nand(cmd_tbl_t * cmdtp, int flag, int argc, char * const argv[]);
+extern int do_esp1800l_flash_util (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[]);
+
+/* return the extension of a filename. returns filename if no extension */
+char *get_extension(char *filename)
+{
+	char *ext = filename;
+	
+	if (ext == NULL)
+		return ext;
+
+	// Work backwards from end of the name to the '.'
+	ext = filename + strlen(filename);
+
+	while ((*(ext-1) != '.') && (ext != filename)) {
+		ext--;
+	}
+
+	return ext;
+}
+
+
+int ReadNetHdBinFile(char *filename)
+{
+	int status;
+	char* cmd1[] = { "fatload" , "usb", "0" , FILE_MEM_ADDR_STRING, filename  };
+	status = do_fat_fsload(NULL, 0, 5 , cmd1);
+	if ( 0 == status)
+	{		
+		saveenv();
+	}
+	else
+	{
+		printf("ERROR: failed to load %s\n", filename);
+	}
+	return status;
+}
+
+int EraseNetHdRegion(void)
+{
+	 int status;
+	//nand erase 0x02400000 ${filesize}
+	//char filesize[16]={0};
+	//char* cmd1[] = { "nand" , "erase", "0x02400000" , & filesize[0] };
+	//strncpy(filesize , getenv("filesize") , sizeof(filesize) ) ;
+	char* cmd1[] = { "nand" , "erase", "0x02400000" , "0x02000000" };
+	status = do_nand(NULL, 0, 4 , cmd1);
+	if ( 0 == status)
+	{		
+		
+	}
+	else
+	{
+		printf("ERROR: unable to erase NAND flash for cavm18_nethd.bin\n");
+	}
+	return status;
+}
+
+int ProgramNetHdToNandFlash(char *filename)
+{
+	int status = 0;;
+	char *ext = get_extension(filename);
+	int retries = 3;
+
+	do {
+		if (0 == strcmp(ext, SECURE_IMAGE_EXTENSION)) {
+			// esp1800l_flash_util
+			char* cmd1[] = { "esp1800l_flash_util" , "--kernel", "--force", FILE_MEM_ADDR_STRING};
+
+			status = do_esp1800l_flash_util(NULL, 0 , 4 , cmd1 ) ;
+			// status will be -EIO on nand error
+		} else {
+			char filesize[16]={0};
+			char* cmd1[] = { "nand" , "write" , FILE_MEM_ADDR_STRING , "0x02400000",  & filesize[0] };
+			strncpy(filesize , getenv("filesize") , sizeof(filesize) ) ;
+
+			status = EraseNetHdRegion();
+			if (0 != status ) {
+				printf("ERROR: fail to erase NAND flash nethd region\n");
+			} else {
+				//nand write 0x02100000 0x02400000 ${filesize}
+				status = do_nand(NULL, 0, 5 , cmd1);
+				if ( 0 != status)
+				{
+					printf("ERROR: unable to write %s to NAND flash\n", filename);
+					status = -EIO;
+				}
+			}
+		}
+	} while ((--retries > 0) && (status == -EIO));
+
+	return status;
+}
+
+// returns 0 if it found valid boot addresses in SPI
+int ubootBootAddrs(int *bootaddr1, int *bootaddr2)
+{
+	int status;
+	char spi_addr[16]={0};
+	char* cmd1[] = { "sfre" , TMP_UBOOT_ADDR_STRING, &spi_addr[0] ,  "4"  };
+	*bootaddr1 = *bootaddr2 = -1;
+
+	strcpy(spi_addr, "0x208");
+
+	// read from 0x0208 from SPI and if it is 0x2c00 it boots from SPI (insecure board). 
+	status = do_sflashre(NULL, 0 , 4 , cmd1 ) ;
+	if (0 != status) {
+		printf("ERROR: fail to read SPI flash\n");
+	} else {
+		*bootaddr1 = (int)*(int *)(TMP_UBOOT_ADDR);
+
+		strcpy(spi_addr, "0xb504");
+
+		// read from 0x0b500 from SPI and to get primary NAND uboot address
+		status = do_sflashre(NULL, 0 , 4 , cmd1 ) ;
+		if (0 != status) {
+			printf("ERROR: fail to read SPI flash\n");
+		} else {
+			*bootaddr2 = (int)*(int *)(TMP_UBOOT_ADDR);
+		}
+	}
+	
+	return status;
+}
+
+int ReadBootLoaderBinFile(char *filename)
+{
+	int status;
+	char* cmd1[] = { "fatload" , "usb", "0" , FILE_MEM_ADDR_STRING, filename  };
+
+	memset((void*) FILE_MEM_ADDR , 0xFF , simple_strtoul ( MAX_UBOOT_SIZE_STRING , NULL, 16 ));
+	status = do_fat_fsload(NULL, 0, 5 , cmd1);
+	if ( 0 == status)
+	{		
+	}
+	else
+	{
+		printf("ERROR: failed to load %s\n", filename);
+	}
+
+	return status;
+}
+
+int EraseSPIUBootRegion(void)
+{
+	int status;
+	char* cmd2[] = { "sfer" , "0", MAX_SPI_UBOOT_SIZE_STRING }; //erase 512K.
+
+	status =  do_sflasher(NULL, 0,3,  cmd2) ;	
+	printf("status = %d\n" , status );
+
+	return status;
+}
+
+int EraseNANDUBootRegion(char *addr)
+{
+	int status;
+	char* cmd1[] = { "nand" , "erase.spread", addr, MAX_UBOOT_SIZE_STRING }; //erase 512K.
+	status = do_nand(NULL, 0, 4 , cmd1);
+	if ( 0 != status)
+	{
+		printf("ERROR: unable to erase NAND flash at address %s\n", addr);
+	}
+
+	return status;
+}
+
+int ProgramUBootToSPIFlash(void)
+{
+	int status;
+	char* cmd1[] = { "sfwr" , FILE_MEM_ADDR_STRING, "0" ,  MAX_SPI_UBOOT_SIZE_STRING  };
+	int bootaddr1, bootaddr2;
+
+	status = ubootBootAddrs(&bootaddr1, &bootaddr2);
+
+	if (status != 0)  {
+	} else if (bootaddr1 != 0x2c00) {
+		printf("ERROR: miniloader in SPI flash does not boot uboot from SPI flash!\n");
+		status = -1;
+	} else {
+		status = EraseSPIUBootRegion();
+		if (status != 0 ) {
+			printf("ERROR: fail to erase SPI flash\n");
+		} else {
+			status = do_sflashwr(NULL, 0 , 4 , cmd1 ) ;
+		}
+	}
+	return status;
+}
+
+int ProgramUBootToNANDFlash(char *filename)
+{
+	int status = 0;
+	int bootaddr1, bootaddr2;
+	char *ext = get_extension(filename);
+	int retries = 3;
+
+	status = ubootBootAddrs(&bootaddr1, &bootaddr2);
+
+	do {
+		if (status != 0)  {
+		} else if (bootaddr1 == 0x2c00) {
+			printf("ERROR: miniloader in SPI flash boots from SPI not NAND!\n");
+			status = -1;
+		} else if (0 == strcmp(ext, SECURE_IMAGE_EXTENSION)) {
+			// esp1800l_flash_util
+			char* cmd1[] = { "esp1800l_flash_util" , "--uboot", "--force", FILE_MEM_ADDR_STRING};
+
+			status = do_esp1800l_flash_util(NULL, 0 , 4 , cmd1 ) ;
+			// status will be -EIO on nand error
+
+		} else {
+			char nand_addr[16]={0};
+			char* cmd1[] = { "nand" , "write", FILE_MEM_ADDR_STRING, &nand_addr[0] ,  MAX_UBOOT_SIZE_STRING  };
+			sprintf(nand_addr, "0x%x", bootaddr2);
+
+			status = EraseNANDUBootRegion(nand_addr);
+			if (status == 0 ) {
+				status = do_nand(NULL, 0 , 5 , cmd1 ) ;
+				if ( 0 != status )
+				{
+					status = -EIO;
+					printf("ERROR: fail to write to nand\n");
+				}
+			}
+		}
+	} while ((--retries > 0) && (status == -EIO));
+
+	return status;
+}
+
+int StartUsbService(void)
+{
+	extern int usb_stor_curr_dev;
+	int status;
+	char* usb_start[] = { "usb" , "start" };
+
+	//printf("Going for UpgradeAllIfRequired\n");
+	status = do_usb(NULL, 0, 2, usb_start );
+	if ( usb_stor_curr_dev < 0)
+	{
+		status = -1;
+	}
+
+	return status;
+}
+//--------------------------------------------------------------------------------------------------
+int StopUsbService(void)
+{
+	int status;
+	char* usb_stop[] = { "usb" , "stop" };
+
+	printf("Usb service is stopped now\n");
+	status = do_usb(NULL, 0, 2, usb_stop );
+
+	return status;
+}
+//--------------------------------------------------------------------------------------------------
+
+void stoupper(char *s)
+{
+	for(; *s; s++)
+	{
+		if(('a' <= *s) && (*s <= 'z'))
+		{
+			*s = 'A' + (*s - 'a');
+		}
+	}
+}
+
+void stolower(char *s)
+{
+	for(; *s; s++)
+	{
+		if(('A' <= *s) && (*s <= 'Z'))
+		{
+			*s = 'a' + (*s - 'A');
+		}
+	}
+}
+
+int do_upgrade(cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	int status;
+	int what_to_upgrade = -1 ;
+	int force = 0;
+	char *filename = SECURE_IMAGE_FILENAME;
+
+	if ((argc < 2) || (argc > 4))
+	{
+		return cmd_usage(cmdtp);
+	}
+
+	stolower((char*) argv[1] );
+	stolower((char*) argv[2] );
+
+	if( 0 == strcmp( argv[1] , "spiuboot" ) )
+	{
+		what_to_upgrade=UPGRADE_SPIUBOOT;
+		filename = INSECURE_UBOOT_IMAGE_FILENAME;
+	}
+	else if( 0 == strcmp( argv[1] , "uboot" ) )
+	{
+		what_to_upgrade=UPGRADE_UBOOT;
+	}
+	else if( 0 == strcmp( argv[1] , "nethd" ) )
+	{
+		what_to_upgrade=UPGRADE_NETHD;
+	}
+	else
+	{
+		return cmd_usage(cmdtp);
+	}
+
+	if( 0 == strcmp( argv[2] , "force" ) )
+	{
+		force=1;
+	}
+
+	if (((force)  && (argc == 4)) ||
+	   ((!force) && (argc == 3)))
+		filename = argv[argc-1];
+
+	status = StartUsbService();
+	if (status != 0 ) {
+		printf("ERROR: fail to start usb service\n");
+		goto exit2;
+	}
+
+	if ( UPGRADE_SPIUBOOT == what_to_upgrade )
+	{
+		if ( 1 == force ) {
+			status = ReadBootLoaderBinFile(filename);
+			if (status == 0 ) {
+				status = ProgramUBootToSPIFlash();
+				if (status != 0 ) {
+					printf("ERROR: fail to program SPI flash\n");
+				}
+			}
+		} else {
+			printf("Expected force option when updating SPI uboot\n");
+		}
+	}
+	else if ( UPGRADE_UBOOT == what_to_upgrade )
+	{
+		if ( 1 == force ) {
+			status = ReadNetHdBinFile(filename);
+			if (status == 0 ) {
+				status = ProgramUBootToNANDFlash(filename);
+				if (status != 0 ) {
+					printf("ERROR: fail to program SPI flash\n");
+				}
+			}
+		} else {
+			printf("Expected force option when updating uboot\n");
+		}
+	}
+	else // kernel image
+	{
+		status = ReadNetHdBinFile(filename);
+		if (status != 0 ) {
+			printf("WARNING: failed to read %s file, trying %s\n",
+					filename, INSECURE_IMAGE_FILENAME);
+			filename = INSECURE_IMAGE_FILENAME;
+			status = ReadNetHdBinFile(filename);
+			if (status != 0 ) {
+				printf("ERROR: failed to read %s.\n", filename);
+			}
+		}
+		if (status == 0) {
+			status = ProgramNetHdToNandFlash(filename);
+			if (status != 0 ) {
+				printf("ERROR: fail to program NAND flash\n");
+			}
+		}
+	}
+
+	status = StopUsbService();
+	if (status != 0 ) {
+		printf("ERROR: fail to stop usb service\n");
+	}
+
+exit2:	
+	return status;
+}
+
+
+
+int AutoFirmwareUpgrade(void)
+{
+	printf("Performing USB_UPDATES2=1\n");
+	return 0;
+}
+
+U_BOOT_CMD(
+	upgrade,	4,	0,	do_upgrade,
+	"Utility to upgrade uboot or nethd image\n",
+	"\tupgrade spiuboot|uboot|nethd [force] [filename]\n"
+	"\t  spiuboot indicates that uboot in SPI flash should be updated with cavm18_bootloader.bin\n"
+	"\t  uboot indicates that uboot image in NAND flash should be updated with cavm18_netHD.sbin or file specified\n"
+	"\t  nethd indicates that nethd image in NAND flash should be updated with cavm18_netHD.sbin or file specified\n"
+	"\n"
+	"\t  force indicates that the upgrade should be done regardless of version or whether uboot was specified\n"
+	);
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_usb2nand.c u-boot-2011.06/common/cmd_usb2nand.c
--- u-boot-2011.06_original/common/cmd_usb2nand.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_usb2nand.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,150 @@
+/*
+ * Copyright 2000-2009
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <command.h>
+#include "cnc_util.h"
+
+DECLARE_GLOBAL_DATA_PTR;
+
+
+//usb2nand filename address spread
+int do_usb2nand (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	#define MAX_RETRY_COUNT 3
+	int status;
+	int ReTryCount=3;
+	//char* flash_address = argv[2];
+	//char filesize[12]={0};
+	UInt32 FlashAddress=0;
+	UInt32 DdrStorageAddress=0;
+	UInt32 DdrVerifyAddress=0;
+
+	int skip_verify=0;
+
+	unsigned int uFileSize;
+	unsigned int MaxFileSize ;
+	
+	FlashAddress = simple_strtol( argv[2], NULL,16);	
+	
+	MaxFileSize = ( (gd->reloc_off -16) & 0xFFFFFFFC) / 2 ;
+
+	DdrStorageAddress=0;	
+	DdrVerifyAddress = MaxFileSize;
+
+	if (argc < 3)
+	{
+		cmd_usage(cmdtp);
+		return -1;
+	}
+
+	if ( 0 == strcmp( argv[3] , "0"))
+	{
+		skip_verify=1;
+		MaxFileSize = ( (gd->reloc_off -16) & 0xFFFFFFFC);
+	}
+
+	printf("NOTE:This command can handle maxiumum file size of %d bytes\n", MaxFileSize);
+	
+	status = cnc_LoadFileFromUsb(argv[1],  DdrStorageAddress, & uFileSize);
+	
+	if (uFileSize < 1 )
+	{
+		printf("ERROR: File Error, count < 1, aborting...\n");
+		return -3;
+	}
+	if (uFileSize > MaxFileSize ) 
+	{
+		printf("ERROR: Input file size too big, please program image manually\n");
+		return -2;
+	}
+	
+	do
+	{				
+		status = cnc_NandErase(FlashAddress ,uFileSize , 1);//erase.spread
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+		
+		status = cnc_NandWrite(DdrStorageAddress ,FlashAddress ,uFileSize, RAW );
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+
+		if (skip_verify == 1)
+		{
+			printf("skipping memory verify\n");
+			ReTryCount=MAX_RETRY_COUNT;
+			break;
+		}
+
+		status = cnc_NandRead(FlashAddress ,DdrVerifyAddress ,uFileSize );
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+		status = memcmp( (void*) DdrStorageAddress , (void*) DdrVerifyAddress ,uFileSize );
+		if (status == 0 )
+		{
+			ReTryCount=MAX_RETRY_COUNT;
+			break;
+		}
+		else
+		{
+			printf("Memory compare fail, trying to reprogram image. Retry count=%d\n", MAX_RETRY_COUNT-ReTryCount);
+		}
+	}while(ReTryCount--);
+
+exit1:
+	if (ReTryCount == 0 )
+	{
+		printf("ERROR: Fail to program Image, please contact vendor\n");
+	}
+	else
+	{
+		if ( 1 == skip_verify )
+		{
+			printf("Image is programmed successfully (but it was not verified)\n");
+		}
+		else
+		{
+			printf("Image is programmed and verified successfully\n");
+		}
+	}
+    return 0;
+}
+
+
+U_BOOT_CMD(
+	usb2nand, 4, 1, do_usb2nand,
+	"filename flash_address",
+	"filename flash_address"
+);
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_usb2spi.c u-boot-2011.06/common/cmd_usb2spi.c
--- u-boot-2011.06_original/common/cmd_usb2spi.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/common/cmd_usb2spi.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,149 @@
+/*
+ * Copyright 2000-2009
+ * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+#include <command.h>
+#include "cnc_util.h"
+
+DECLARE_GLOBAL_DATA_PTR;
+
+//usb2spi filename address
+int do_usb2spi (cmd_tbl_t *cmdtp, int flag, int argc, char * const argv[])
+{
+	#define MAX_RETRY_COUNT 3
+	int status;
+	int ReTryCount=3;
+	//char* flash_address = argv[2];
+	//char filesize[12]={0};
+	UInt32 FlashAddress=0;
+	UInt32 DdrStorageAddress=0;
+	UInt32 DdrVerifyAddress=0;
+
+	int skip_verify=0;
+
+	unsigned int uFileSize;
+	unsigned int MaxFileSize ;
+	
+	FlashAddress = simple_strtol( argv[2], NULL,16);	
+	
+	MaxFileSize = ( (gd->reloc_off -16) & 0xFFFFFFFC) / 2 ;
+
+	DdrStorageAddress=0;	
+	DdrVerifyAddress = MaxFileSize;
+
+	if (argc < 3)
+	{
+		cmd_usage(cmdtp);
+		return -1;
+	}
+
+	if ( 0 == strcmp( argv[3] , "0"))
+	{
+		skip_verify=1;
+		MaxFileSize = ( (gd->reloc_off -16) & 0xFFFFFFFC);
+	}
+
+	printf("NOTE:This command can handle maxiumum file size of %d bytes\n", MaxFileSize);
+	
+	status = cnc_LoadFileFromUsb(argv[1],  DdrStorageAddress, & uFileSize);
+	
+	if (uFileSize < 1 )
+	{
+		printf("ERROR: File Error, count < 1, aborting...\n");
+		return -3;
+	}
+	if (uFileSize > MaxFileSize ) 
+	{
+		printf("ERROR: Input file size too big, please program image manually\n");
+		return -2;
+	}
+	
+	do
+	{				
+		status = cnc_SpiErase(FlashAddress ,uFileSize);
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+		
+		status = cnc_SpiWrite(DdrStorageAddress ,FlashAddress ,uFileSize );
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+
+		if (skip_verify == 1)
+		{
+			printf("skipping memory verify\n");
+			ReTryCount=MAX_RETRY_COUNT;
+			break;
+		}
+
+		status = cnc_SpiRead(FlashAddress ,DdrVerifyAddress ,uFileSize );
+		if (status != 0 )
+		{
+			ReTryCount=0;
+			goto exit1;
+			return -1;
+		}
+		status = memcmp( (void*) DdrStorageAddress , (void*) DdrVerifyAddress ,uFileSize );
+		if (status == 0 )
+		{
+			ReTryCount=MAX_RETRY_COUNT;
+			break;
+		}
+		else
+		{
+			printf("Memory compare fail, trying to reprogram image. Retry count=%d\n", MAX_RETRY_COUNT-ReTryCount);
+		}
+	}while(ReTryCount--);
+
+exit1:
+	if (ReTryCount == 0 )
+	{
+		printf("ERROR: Fail to program Image, please contact vendor\n");
+	}
+	else
+	{
+		if ( 1 == skip_verify )
+		{
+			printf("Image is programmed successfully (but it was not verified)\n");
+		}
+		else
+		{
+			printf("Image is programmed and verified successfully\n");
+		}
+	}
+    return 0;
+}
+
+
+U_BOOT_CMD(
+	usb2spi, 3, 1, do_usb2spi,
+	"filename flash_address",
+	"filename flash_address"
+);
diff '--exclude=.svn' -Naur u-boot-2011.06_original/common/cmd_usb.c u-boot-2011.06/common/cmd_usb.c
